package com.adventurer_engine.common.entity.ai.branch_nodes.control;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.adventurer_engine.common.entity.ai.AIObject;
import com.adventurer_engine.common.entity.ai.NodeBase;
import com.adventurer_engine.common.entity.ai.NodeStatus;
import com.adventurer_engine.common.entity.ai.branch_nodes.ControlNode;
import com.adventurer_engine.util.Tools;

public class RandomSelectNode extends ControlNode {
  public static final String INTERNAL_NAME = "random_select";
  
  public int[] weight;
  
  private int weightSum = 0;
  
  public RandomSelectNode(AIObject ai) {
    super(ai);
  }
  
  public String internalName() {
    return "random_select";
  }
  
  public NodeBase copy(AIObject ai) {
    com.adventurer_engine.common.entity.ai.branch_nodes.control.RandomSelectNode node = new com.adventurer_engine.common.entity.ai.branch_nodes.control.RandomSelectNode(ai);
    node.child = copyChild(ai);
    node.weight = this.weight;
    node.weightSum = this.weightSum;
    return (NodeBase)node;
  }
  
  public NodeStatus onChildReportRUNNING() {
    return NodeStatus.RUNNING;
  }
  
  public NodeStatus onChildReportSUCCESS() {
    return NodeStatus.SUCCESS;
  }
  
  public NodeStatus onChildReportFAILURE() {
    return NodeStatus.FAILURE;
  }
  
  public NodeStatus onParentSendInit() {
    if (this.child.isEmpty()) {
      getParent().actionTick(NodeStatus.SUCCESS);
      return NodeStatus.SUCCESS;
    } 
    int idx = randomWeightInteger(this.weight, this.weightSum);
    if (idx == -1) {
      getParent().actionTick(NodeStatus.FAILURE);
      return NodeStatus.FAILURE;
    } 
    return executeChildNode(idx);
  }
  
  private int randomWeightInteger(int[] weight, int max) {
    if (weight.length == 0)
      return -1; 
    if (this.weightSum == 0)
      for (int j : weight)
        this.weightSum += j;  
    if (this.weightSum == 0)
      return -1; 
    int r = Tools.random.nextInt(this.weightSum);
    int cur = 0;
    for (int i = 0; i < weight.length; i++) {
      cur += weight[i];
      if (r < cur)
        return i; 
    } 
    return -1;
  }
}
